=== debian/control ===
Source: lfc-postgres
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
Build-Depends: debhelper (>= 5), quilt, gsoap, libpq-dev, uuid-dev, liblcgdm-dev, liblfc-dev, xutils-dev
Standards-Version: 3.8.4
Section: net
DM-Upload-Allowed: yes
Vcs-Browser: http://svn.nordugrid.org/trac/packaging/browser/debian/lfc-postgres
Vcs-Svn: http://svn.nordugrid.org/repos/packaging/debian/lfc-postgres
Homepage: http://glite.web.cern.ch/glite/

Package: lfc-postgres
Provides: lfcdaemon
Architecture: any
Depends: adduser, ${shlibs:Depends}, ${misc:Depends}
Description: LCG File Catalog (LFC) server with postgres database backend
 The LCG File Catalog (LFC) keeps track of the locations of the physical
 replicas of the logical files in a distributed storage system. 
 This package provides an LFC server that uses postgres as its database
 backend.
